VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Cloud_Shadow_Display, Prof. Mack Grady, Baylor University, March 18, 2014"
   ClientHeight    =   9255
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   11910
   LinkTopic       =   "Form1"
   ScaleHeight     =   9255
   ScaleWidth      =   11910
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Num_Pass_Textbox 
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Text            =   "Num_Pass_Textbox"
      Top             =   8640
      Width           =   1575
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   3480
      Top             =   240
   End
   Begin VB.ListBox Info_Listbox 
      Height          =   1230
      Left            =   2640
      TabIndex        =   3
      Top             =   7800
      Width           =   9015
   End
   Begin VB.ListBox Coordinates_Repeated_Listbox 
      Height          =   6690
      Left            =   2640
      TabIndex        =   2
      Top             =   840
      Width           =   1935
   End
   Begin VB.ListBox Coordinates_Listbox 
      Height          =   7665
      Left            =   120
      TabIndex        =   1
      Top             =   840
      Width           =   2415
   End
   Begin VB.CommandButton Coordinates_Command_Button 
      Caption         =   "READ COORDINATES"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2175
   End
   Begin VB.Line Line_Bottom 
      X1              =   4680
      X2              =   11520
      Y1              =   7560
      Y2              =   7560
   End
   Begin VB.Line Line_Right 
      X1              =   11520
      X2              =   11520
      Y1              =   840
      Y2              =   7560
   End
   Begin VB.Line Line_Top 
      X1              =   4680
      X2              =   11520
      Y1              =   840
      Y2              =   840
   End
   Begin VB.Line Line_Left 
      X1              =   4680
      X2              =   4680
      Y1              =   840
      Y2              =   7560
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Coordinates_Command_Button_Click()
Static dataline As String, busname(45) As String, bname As String
Static comma As String * 1
Static xcoord(45) As Single, ycoord(25) As Single, xc As Single, yc As Single
Static busnum(25) As Integer, num As Integer, icomma1 As Integer, j As Integer
Static icomma2 As Integer, nbuses As Integer, num_old As Integer
Static xc_min As Single, xc_max As Single, yc_min As Single, yc_max As Single
Static nbext(9999) As Integer, lfrom(100) As Integer, lto(100) As Integer
Static num_pass As Integer, klines As Integer, k As Integer
Dim bus_from As String, bus_to As String


num_pass = num_pass + 1
Num_Pass_Textbox.Text = num_pass
If num_pass > 1 Then
  GoTo startplot
End If

comma = ","
nbuses = 0
num_old = 0
klines = 0

Open "cloud_bus_coords_connections.txt" For Input As #1
Do Until EOF(1)
  Line Input #1, dataline
  Coordinates_Listbox.AddItem dataline
  If InStr(dataline, "bus_coordinates") Then
    GoTo keepgoing_1
  End If
  If InStr(dataline, "bus_connections") Then
   GoTo connections
  End If
  
  icomma1 = 0
  icomma2 = InStr(icomma1 + 1, dataline, comma)
  num = Mid(dataline, icomma1 + 1, icomma2 - icomma1 - 1)
  If (num = num_old) Then GoTo keepgoing_1  'this happens only on bus with multiple nonlinear loads
  
  num_old = num
  nbuses = nbuses + 1
  nbext(nbuses) = num
  'Coordinates_Listbox.AddItem num
  
  icomma1 = icomma2
  icomma2 = InStr(icomma1 + 1, dataline, comma)
  bname = Mid(dataline, icomma1 + 1, icomma2 - icomma1 - 1)
  'Coordinates_Listbox.AddItem bname
  busname(nbuses) = bname
  
  icomma1 = icomma2
  icomma2 = InStr(icomma1 + 1, dataline, comma)
  xc = Mid(dataline, icomma1 + 1, icomma2 - icomma1 - 1)
  'Coordinates_Listbox.AddItem xc
  xcoord(nbuses) = xc
  
  icomma1 = icomma2
  icomma2 = Len(dataline) + 1
  yc = Mid(dataline, icomma1 + 1, icomma2 - icomma1 - 1)
  'Coordinates_Listbox.AddItem yc
  ycoord(nbuses) = yc
  
  dataline = num
  dataline = dataline & comma & busname(nbuses)
  dataline = dataline & comma & xcoord(nbuses)
  dataline = dataline & comma & ycoord(nbuses)
  Coordinates_Repeated_Listbox.AddItem dataline
  
keepgoing_1:
Loop

'bus connections
connections:
klines = 0
Do Until EOF(1)
  Line Input #1, dataline
  Coordinates_Listbox.AddItem dataline
  icomma1 = InStr(1, dataline, comma)
  bus_from = Mid(dataline, 1, icomma1 - 1)
  bus_to = Mid(dataline, icomma1 + 1, Len(dataline) - icomma1)
  klines = klines + 1
  lfrom(klines) = CInt(bus_from)
  lto(klines) = CInt(bus_to)
  dataline = klines & comma & lfrom(klines) & comma & lto(klines)
  Coordinates_Repeated_Listbox.AddItem dataline
Loop

Close #1

For j = 1 To nbuses
  If j = 1 Then
    xc_min = 1000000#
    xc_max = -1000000#
    yc_min = 1000000#
    yc_max = -1000000#
  End If
  If xcoord(j) > xc_max Then
    xc_max = xcoord(j)
  End If
  If xcoord(j) < xc_min Then
    xc_min = xcoord(j)
  End If
  If ycoord(j) > yc_max Then
    yc_max = ycoord(j)
  End If
  If ycoord(j) < yc_min Then
    yc_min = ycoord(j)
  End If
Next j
Coordinates_Repeated_Listbox.AddItem "xc_min = " & xc_min
Coordinates_Repeated_Listbox.AddItem "xc_max = " & xc_max
Coordinates_Repeated_Listbox.AddItem "yc_min = " & yc_min
Coordinates_Repeated_Listbox.AddItem "yc_max = " & yc_max

xc_min = xc_min - 0.5
xc_max = xc_max + 0.5
yc_min = yc_min - 0.5
yc_max = yc_max + 0.5

'----------------------
Static littlebit As Integer
Static X1 As Integer, Y1 As Integer, X2 As Integer, Y2 As Integer
Static Xcenter As Integer, Ycenter As Integer, Xcircle As Integer
Static Ycircle As Integer, kdiam As Integer, jline As Integer
Static Xwide As Integer, Ytall As Integer, kcol As Integer, kcol_max As Integer
Static jline_max As Integer, icolor As Integer
Static xfract As Single, yfract As Single, delta As Single
Static deltax As Single, deltay As Single, pv_data As Single
Static pv_intensity(2000, 25), pv_time(2000)

littlebit = 200
X1 = Line_Left.X1 + littlebit
Y1 = Line_Left.Y1 + littlebit
X2 = Line_Right.X2 - littlebit
Y2 = Line_Right.Y2 - littlebit

'Clear the plot area
Line (Line_Left.X1 + 20, Line_Left.Y1 + 20)-(Line_Right.X2 - 20, Line_Right.Y2 - 20), QBColor(15), BF

'Line (X1, Y1)-(X2, Y2), QBColor(1), B

'practice
Xcenter = (X1 + X2) / 2    'pixels
Ycenter = (Y1 + Y2) / 2    'pixels
'Circle (Xcenter, Ycenter), 100, QBColor(2)

Xwide = X2 - X1    'hotizontal pixels     '
Ytall = Y2 - Y1    'vertical pixels
deltax = xc_max - xc_min    'horizontal km
deltay = yc_max - yc_min    'vertical km
delta = deltax    'km
If deltay > deltax Then
  delta = deltay  'delta km is the max of horiz. km and vert. km
End If

'center the height or width, whichever is shorter

If deltax > deltay Then  'wider than tall
  Y2 = Y2 - (deltax - deltay) / deltay * Ytall / 4#
  Y1 = Y1 - (deltax - deltay) / deltay * Ytall / 4#
End If

'Draw the bus circles
'For j = 1 To nbuses
'  xfract = (xcoord(j) - xc_min) / delta  'pu of window horizontal
'  yfract = (ycoord(j) - yc_min) / delta  'pu of window horizontal
'  Xcircle = X1 + xfract * (X2 - X1)
'  Ycircle = Y2 - yfract * (Y2 - Y1)
'  For kdiam = 100 To 100 Step 1
'    Circle (Xcircle, Ycircle), kdiam, QBColor(1)
'  Next kdiam
'Next j

Open "cloud_sun_intensity_table.txt" For Input As #1
  For j = 1 To 6
    Line Input #1, dataline
    Info_Listbox.AddItem dataline
  Next j

  jline = 0
  kcol_max = -9999
  Do Until EOF(1)
    icomma2 = 0
    Line Input #1, dataline
    jline = jline + 1
    kcol = 0
    If jline = 1 Then
      Info_Listbox.AddItem dataline
    End If
    
    Do
      icomma1 = icomma2
      icomma2 = InStr(icomma1 + 1, dataline, comma)
      kcol = kcol + 1
      If icomma2 <> 0 Then
        'all columns excep the last one
        pv_data = Mid(dataline, icomma1 + 1, icomma2 - icomma1 - 1)
        If kcol = 1 Then  'time is in column 1
          pv_time(jline) = pv_data
          Else
          pv_intensity(jline, kcol - 1) = pv_data 'starts in column 2
        End If
        GoTo keepgoing_2
        
        Else
       'last column in the line
        pv_data = Mid(dataline, icomma1 + 1, Len(dataline) - icomma1)
        pv_intensity(jline, kcol - 1) = pv_data
        kcol_max = kcol
        GoTo exitloop_2
      End If
keepgoing_2:
    Loop
exitloop_2:
  Loop
  Close #1
  
  Info_Listbox.AddItem dataline
  dataline = pv_time(jline)
  For kcol = 2 To kcol_max
    dataline = dataline & comma & pv_intensity(jline, kcol - 1)
  Next kcol
  Info_Listbox.AddItem dataline

  jline_max = jline
  jline = 1
  
Dim cloudcenters As String, xchar As String, ychar As String
Dim jchar As String
Static xval As Single, yval As Single, xsquare As Single
Static ysquare As Single, dxlen As Single, dylen As Single, pi As Single
Static rxcos As Single, rxsin As Single, rycos As Single, rysin As Single
Dim jval As Integer

Static csidechar As String, crad1char As String, crad2char As String, azichar As String
Static cside As Single, crad1 As Single, crad2 As Single, azi As Single

Static cpv1char As String
Static cpv1 As Single

pi = 3.1415926

Open "cloud_centers_plot.txt" For Input As #1
Line Input #1, cloudcenters
Line Input #1, cloudcenters
Line Input #1, cloudcenters
Line Input #1, cloudcenters
icomma1 = 0
icomma2 = InStr(icomma1 + 1, cloudcenters, comma)

icomma1 = icomma2
icomma2 = InStr(icomma1 + 1, cloudcenters, comma)

icomma1 = icomma2
icomma2 = InStr(icomma1 + 1, cloudcenters, comma)

icomma1 = icomma2
icomma2 = InStr(icomma1 + 1, cloudcenters, comma)
csidechar = Mid(cloudcenters, icomma1 + 1, icomma2 - icomma1 - 1) 'square side length, km
cside = CSng(csidechar) 'km

icomma1 = icomma2
icomma2 = InStr(icomma1 + 1, cloudcenters, comma)
crad1char = Mid(cloudcenters, icomma1 + 1, icomma2 - icomma1 - 1) 'shadow inner radius, km
crad1 = CSng(crad1char) 'km

icomma1 = icomma2
icomma2 = InStr(icomma1 + 1, cloudcenters, comma)
crad2char = Mid(cloudcenters, icomma1 + 1, icomma2 - icomma1 - 1) 'shadow outer radius, km
crad2 = CSng(crad2char) 'km

icomma1 = icomma2
icomma2 = InStr(icomma1 + 1, cloudcenters, comma)

icomma1 = icomma2
icomma2 = InStr(icomma1 + 1, cloudcenters, comma)
azichar = Mid(cloudcenters, icomma1 + 1, icomma2 - icomma1 - 1) 'azimuth angle, degrees
azi = CSng(azichar) 'degrees

icomma1 = icomma2
icomma2 = InStr(icomma1 + 1, cloudcenters, comma)
cpv1char = Mid(cloudcenters, icomma1 + 1, icomma2 - icomma1 - 1) 'per unit of max
cpv1 = CSng(cpv1char) 'per unit of pmax

dxlen = (X2 - X1) / delta * cside  'pixels / km * km = pixels
dylen = (Y2 - Y1) / delta * cside  'pixels / km * km = pixels

rxcos = Sqr(2#) / 2# * dxlen * Cos((azi - 45#) * pi / 180#) 'pixels
rxsin = Sqr(2#) / 2# * dxlen * Sin((azi - 45#) * pi / 180#) 'pixels
rycos = Sqr(2#) / 2# * dylen * Cos((azi - 45#) * pi / 180#) 'pixels
rysin = Sqr(2#) / 2# * dylen * Sin((azi - 45#) * pi / 180#) 'pixels

startplot:

'Draw inner box
Line (Line_Left.X1 - 20, Line_Left.Y1 - 20)-(Line_Right.X2 + 20, Line_Right.Y2 + 20), QBColor(15), BF

Do Until EOF(1)
 icomma1 = 0
 Line Input #1, cloudcenters
 icomma2 = InStr(icomma1 + 1, cloudcenters, comma)
 jchar = Mid(cloudcenters, icomma1 + 1, icomma2 - icomma1 - 1)
 jval = CInt(jchar)
 If jval = jline Then
   icomma1 = icomma2
   icomma2 = InStr(icomma1 + 1, cloudcenters, comma)
   xchar = Mid(cloudcenters, icomma1 + 1, icomma2 - icomma1 - 1)
   xval = CSng(xchar)
   icomma1 = icomma2
   ychar = Mid(cloudcenters, icomma1 + 1, Len(cloudcenters) - icomma1)
   yval = CSng(ychar)
   yval = CSng(ychar)
   
   DrawStyle = 2
   
   Dim rad1_pix As Single, rad2_pix As Single
   
' plot the grid squares and circles
   If (xval >= xc_min) And (xval <= xc_max) Then
     If (yval >= yc_min) And (yval <= yc_max + cside) Then
       xfract = (xval - xc_min) / delta
       yfract = (yval - yc_min) / delta
       xsquare = X1 + xfract * (X2 - X1)
       ysquare = Y2 - yfract * (Y2 - Y1)
       
       rad1_pix = (X2 - X1) / delta * crad1
       rad2_pix = (X2 - X1) / delta * crad2
       
       Line (xsquare + rxsin, ysquare - rycos)-(xsquare + rxcos, ysquare + rysin), QBColor(1)
       Line (xsquare + rxcos, ysquare + rysin)-(xsquare - rxsin, ysquare + rycos), QBColor(1)
       Line (xsquare - rxsin, ysquare + rycos)-(xsquare - rxcos, ysquare - rysin), QBColor(1)
       Line (xsquare - rxcos, ysquare - rysin)-(xsquare + rxsin, ysquare - rycos), QBColor(1)
       Circle (xsquare, ysquare), rad1_pix, DrawStyle = 0
       Circle (xsquare, ysquare), rad2_pix, DrawStyle = 0
       
      End If
   End If
 End If
 DrawStyle = 0
 If jval > jline Then
   GoTo exitloop
 End If
Loop
exitloop:

'Draw the bus circles
For j = 1 To nbuses
  xfract = (xcoord(j) - xc_min) / delta
  yfract = (ycoord(j) - yc_min) / delta
  Xcircle = X1 + xfract * (X2 - X1)
  Ycircle = Y2 - yfract * (Y2 - Y1)
  For kdiam = 50 To 50 Step 1
    Circle (Xcircle, Ycircle), kdiam, QBColor(1)
  Next kdiam
Next j

Dim jfrom As Integer, jto As Integer
Dim xx1 As Single, yy1 As Single, xx2 As Single, yy2 As Single
Dim xf1 As Single, yf1 As Single, xf2 As Single, yf2 As Single

'Draw the bus connections
For k = 1 To klines
  jfrom = lfrom(k)
  jto = lto(k)
  xf1 = (xcoord(jfrom) - xc_min) / delta
  yf1 = (ycoord(jfrom) - yc_min) / delta
  xf2 = (xcoord(jto) - xc_min) / delta
  yf2 = (ycoord(jto) - yc_min) / delta
  
  xx1 = X1 + xf1 * (X2 - X1)
  yy1 = Y2 - yf1 * (Y2 - Y1)
  
  xx2 = X1 + xf2 * (X2 - X1)
  yy2 = Y2 - yf2 * (Y2 - Y1)
  
  Line (xx1, yy1)-(xx2, yy2), QBColor(1)
Next k

' Color insides of the bus circles
  Dim jdum As Integer
  jdum = 0
'  For jline = 1 To jline_max Step 100
  For j = 1 To nbuses
    xfract = (xcoord(j) - xc_min) / delta
    yfract = (ycoord(j) - yc_min) / delta
    Xcircle = X1 + xfract * (X2 - X1)
    Ycircle = Y2 - yfract * (Y2 - Y1)
    icolor = 0
    
    If pv_intensity(jline, j) > 0.99 Then
      icolor = 12
      Else
      If pv_intensity(jline, j) > cpv1 Then
        icolor = 10
        Else
        icolor = 1
      End If
    End If
    
    For kdiam = 15 To 85 Step 10
      Circle (Xcircle, Ycircle), kdiam, QBColor(icolor)
    Next kdiam
  Next j
  
  jline = jline + 1
  Timer1.Enabled = True
  
  If jline > jline_max Then
    Timer1.Enabled = False
    Close #1
  End If
'  Next jline

finished:
'Close #1
End Sub

Private Sub Timer1_Timer()
Call Coordinates_Command_Button_Click

End Sub
